#define VERSION "0.20"

// #define NAKEN_HOST "nakenchat.naken.cc"
#define DEFAULT_NAKEN_PORT 6666
#define DEFAULT_NAKEN_TIMEOUT 10
#define DEFAULT_COLOR_RC_FILE ".ncurs_color"
#define COLOR_TEMP_FILE ".ncurs_temp"
#define BUFSIZE 2048
#define HIST 25
#define DELIM_CHAR '-'

#include <stdio.h>
#include <stdlib.h>
#include <ncurses.h>
#include <curses.h>
#include <sys/time.h>
#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include <sys/socket.h>
#include <time.h>
#include <unistd.h>
#include "socket_funcs.h"
#include <sys/stat.h>
#include <fcntl.h>



int    debug = 1;
int    lines_org = 0, cols_org = 0;
int    Wt_lin, Wt_col, Wi_lin, Wi_col;
int    S = -1;
int    c = -1;
int    regular_char = 1;
int    x = 0;
int    max_x = 0;
int    allow_color;
char   send_text[BUFSIZE];
char   undo_buf[BUFSIZE];
char   naken_host[255];
int    naken_port = 0;
int    naken_timeout;
char   color_rc_file[255];
char   color_temp_file[255];
char   c_pid[32];
char   myname[255];
char	 command[255];
WINDOW *Wi, *Wt, *Delim, *Subinfo, *Authtxt, *logwin;
// Emacs vars
int    Cl_sec1=0; 
int    Cl_sec2=0;
int    metachar = 0;
int    C_x_char = 0;
// X Y, vars for Windows
int    Wi_x, Wi_y, Wt_x, Wt_y;
int    log_to_file = 0;
int    logdate = 0;
char   logfile[255];
// Only used for debug logging
FILE *lg;
char fifo[255];
int    use_fifo = 0;
int	 disable_beep = 0;
int	 pid;
char history[HIST][BUFSIZE];
int	 in_history = 0, max_history = 0;
int  db_lines = 0, db_maxlen = 0;
int	 ok_complet = -1;  // Not ok at start time
int  last_char;
int  ncurs_db_errno = 0;


int  call_server (char *naken_server, int PORT, int TIMEOUT);
void set_timer   (int time_out_sec);
void sig_handler (int sig);
void cleanup_exit(char *msg, int errnum);
int  handle_input(void);
int  emacs_check(int c);
int  log (int X, int C, char *msg);
int  recv_text(void);
int  set_color(void);
int set_up_color(char *rcfile, char *temp_file);
int set_ncolor(char *text, char *temp_file, WINDOW *win);
int get_options(int argc, char **argv);
int check_valid_keys(int c);
void welcome_msg(WINDOW *win);
void print_usage(void);
int check_local_command(char *cmd);
int do_commands(char *filename);
int clearWi(int size);
char *datestr(FILE *logfile);
int write_fifo (char *string, int command);
void trav_history(int way);
int tab_complet(int comm);
void get_logged_in(void);

