#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>

#define	MAXHOSTNAME	255

// code to establish a socket; originally from bzs@bu-cs.bu.edu
int establish(unsigned short portnum)
{ 
	  char   myname[MAXHOSTNAME+1];
	  int    s;
	  struct sockaddr_in sa;
	  struct hostent *hp;

	  memset(&sa, 0, sizeof(struct sockaddr_in)); /* clear our address */
	  gethostname(myname, MAXHOSTNAME);           /* who are we? */
	  hp= gethostbyname(myname);                  /* get our address info */
	  if (hp == NULL)                             /* we don't exist !? */
	    return(-1);
	  sa.sin_family= hp->h_addrtype;              /* this is our host address */
	  sa.sin_port= htons(portnum);                /* this is our port number */
	  if ((s= socket(AF_INET, SOCK_STREAM, 0)) < 0) /* create socket */
	    return(-1);
	  if (bind(s,(struct sockaddr *)&sa,sizeof(struct sockaddr_in)) < 0) {
	    close(s);
	    return(-1);                               /* bind address to socket */
	  }
	  listen(s, 3);                               /* max # of queued connects */
	  return(s);
}

// wait for a connection to occur on a socket created with establish()
int get_connection(int s)
{ 
	int t;                  /* socket of connection */
	struct sockaddr_in their_addr; /* connector's address information */
	int sin_size;


  	sin_size = sizeof(struct sockaddr_in);
  	if ((t = accept(s, (struct sockaddr *)&their_addr, &sin_size)) < 0)   /* accept connection if there is one */
    	return(-1);
 	
	printf("got connection from %s\n", inet_ntoa(their_addr.sin_addr));
	return(t);
}

int call_socket(char *hostname, unsigned short portnum)
{ struct sockaddr_in sa;
  struct hostent     *hp;
  int a, s;


  if ((hp= gethostbyname(hostname)) == NULL) { /* do we know the host's */
    errno= ECONNREFUSED;                       /* address? */
    return(-1);                                /* no */
  }

  memset(&sa,0,sizeof(sa));
  memcpy((char *)&sa.sin_addr,hp->h_addr,hp->h_length);     /* set address */
  sa.sin_family= hp->h_addrtype;
  sa.sin_port= htons((u_short)portnum);

  if ((s= socket(hp->h_addrtype,SOCK_STREAM,0)) < 0)     /* get socket */
    return(-1);
  if (connect(s,(struct sockaddr *)&sa,sizeof sa) < 0) { /* connect */
    close(s);
    return(-1);
  }
  return(s);
}
