
/* This program is licensed by the well known GPL license, */
/* (Gnu General Public License) */
/* Bug reports, RFE's or comments can be sent to author: */
/* Erik Ahlstrm, eah@proact.se, (or seeah@linux.com, prio 2) */


#include "include/naken_curs.h"


int main(int argc, char **argv)
{

  fd_set rfds_S;
  struct timeval tv;
  int data_on_sock;
  long re_read_config = 0;

  pid = getpid();


  // lg = fopen("/dev/null", "w");
  // lg = fopen("/dev/pts/0", "w");
  
  get_options(argc, argv);

  signal(SIGINT, sig_handler);
  initscr();
  noecho();
  start_color();
  
  printw("Connecting to %s on port %d, Timeout is %d seconds.",
		naken_host, naken_port, naken_timeout);
  refresh();
  usleep(500000);
  S = call_server(naken_host, naken_port, naken_timeout);    

  // Set up temp file
  sprintf(color_temp_file, "/tmp/%s.%d", COLOR_TEMP_FILE, getpid());

  set_up_windows();
  set_up_color(color_rc_file, color_temp_file);
  set_ncolor(".Winput", color_temp_file, Wi);
  set_ncolor(".Wtext", color_temp_file, Wt);
  set_ncolor(".default_user", color_temp_file, Wt);
  wrefresh(Wt);
  wrefresh(Wi);

	// set up completion
	ok_complet = tab_complet(1);
	// fprintf(lg, "setting up complete... = %d\n", ok_complet);

  write(S, myname, strlen(myname));
  strcpy(send_text, "Connected with | Naken_Curs, version ");
  strcat(send_text, VERSION);
  strcat(send_text, " |\n");
  write(S, send_text, strlen(send_text));
  memset(send_text, 0, sizeof(send_text));

  while (1==1) {
    if (lines_org != LINES || cols_org != COLS) {
      clear();
      set_up_windows();
      refresh();
    }
    re_read_config++;

    if ( re_read_config == 1000 ) {
			set_up_color(color_rc_file, color_temp_file);
  		set_ncolor(".Winput", color_temp_file, Wi);
  		set_ncolor(".Wtext", color_temp_file, Wt);
  		set_ncolor(".default_user", color_temp_file, Wt);
			re_read_config = 0;
			// get_logged_in();
    }

    FD_ZERO(&rfds_S);
    FD_SET(S, &rfds_S);
    tv.tv_sec = 0;
    tv.tv_usec = 5000;
    data_on_sock = -1;
    data_on_sock = select(S+1, &rfds_S, NULL, NULL, &tv);
    switch (data_on_sock) {
    case 0:
      handle_input();
      break;
    case -1:
      // cleanup_exit("Select on Socket failed!", errno);
      break;
    default:
      recv_text();
      break;
    }
  }
  unlink(color_temp_file);
  close(S);
  endwin();
}



int call_server(char *naken_server, int PORT, int TIMEOUT) {
  int Sock;
  signal(SIGALRM, sig_handler);
  set_timer(TIMEOUT);
  
  if((Sock = call_socket(naken_server, PORT)) < 0 ) {
    cleanup_exit("Connection failed", errno);
  }
  
  return(Sock);
}


int check_local_command(char *cmd)
{
  char tmp_input[64];
  char tmp_input_string[64];
  FILE *tmp_fp;
  int  fg, bg;
  int  resp;
  int  count1, count2;

  if(strcmp(send_text, ".adduser\n") == 0 ) {
    nodelay(Wi, FALSE);
    init_pair(3, 4, 3);
    wcolor_set(Wi, 3, NULL);
    wmove(Wi, 0, 0);
    wprintw(Wi, "Username:");
    set_ncolor(".Winput", color_temp_file, Wi);
    wprintw(Wi, " ");
    wrefresh(Wi);
    wgetstr(Wi, tmp_input);
    strcpy(tmp_input_string, tmp_input);
    strcat(tmp_input_string, "=");
    
    wmove(Wi, 0, 0);
    clearWi(BUFSIZE);
    wcolor_set(Wi, 3, NULL);
    wprintw(Wi, "Foreground: (0-%d)", COLORS);
    memset(tmp_input, 0, strlen(tmp_input));
    set_ncolor(".Winput", color_temp_file, Wi);
    wprintw(Wi, " ");
    wrefresh(Wi);
    wgetstr(Wi, tmp_input);
    strcat(tmp_input_string, tmp_input);
    strcat(tmp_input_string, ":");
    fg = atol(tmp_input);
    
    clearWi(BUFSIZE);
    wcolor_set(Wi, 3, NULL);
    wprintw(Wi, "Background: (0-%d)", COLORS);
    memset(tmp_input, 0, strlen(tmp_input));
    set_ncolor(".Winput", color_temp_file, Wi);
    wprintw(Wi, " ");
    wrefresh(Wi);
    wgetstr(Wi, tmp_input);
    strcat(tmp_input_string, tmp_input);
    bg = atol(tmp_input);
    
    clearWi(BUFSIZE);
    wmove(Wi, 0, 0);
    init_pair(4, fg, bg);
    wcolor_set(Wi, 4, NULL);
    wprintw(Wi, "Add: \"%s\"  Ok? [Y/n]", tmp_input_string);
    wrefresh(Wi);
    resp = wgetch(Wi);
    if (resp != 10 && resp != 'y' && resp != 'Y') {
      clearWi(BUFSIZE);
      wmove(Wi, 0, 0);
      wcolor_set(Wi, 3, NULL);
      wprintw(Wi, "Cancel, No changes made.");
      wrefresh(Wi);
      sleep(2);
      clearWi(BUFSIZE);
      return(1);
    }


    unlink(color_temp_file);
    if ((tmp_fp = fopen(color_rc_file, "a")) ==  NULL){
      clearWi(BUFSIZE);
      wprintw(Wi, "%s could not be opened!", color_rc_file);
      wrefresh(Wi);
      sleep(3);
      clearWi(BUFSIZE);
    } else {
      // fprintf(tmp_fp, "%s\n", tmp_input_string);
      fclose(tmp_fp);
      clearWi(BUFSIZE);
      wmove(Wi, 0, 0);
      wprintw(Wi, "%s, added to rc file!", tmp_input_string);
      wrefresh(Wi);
      sleep(2);
      wmove(Wi, 0, 0);
      clearWi(BUFSIZE);
      wrefresh(Wi);
      x = 0;
      max_x = 0;
    }
    set_up_color(color_rc_file, color_temp_file);
    return(1);
  }

  if (send_text[0] == '@') {
    memset(tmp_input, 0, sizeof(tmp_input));
    count1 = 1;
    count2 = 0;
    while (send_text[count1] != '\n' && count1 < strlen(send_text)) {
      tmp_input[count2] = send_text[count1];
      count2++; count1++;
    }
    tmp_input[count2] = 0;
    do_commands(tmp_input);
    clearWi(BUFSIZE);
    return(1);
  }
  

  return(0);
}








int check_valid_keys(int c) 
{
  int valid = 0;
  
  if (c >= 32 && c <= 126) {
    valid = 1;
  }

  switch (c) {
  case 1:
    valid = 1;
    break;
  case 5:
    valid = 1;
    break;
  case 8:
    valid = 1;
    break;
  case 9:
    valid = 1;
    break;
  case 10:
    valid = 1;
    break;
  case 11:
    valid = 1;
    break;
  case 12:
    valid = 1;
    break;
  case 21:
    valid = 1;
    break;
  case 228:
    valid = 1;
    break;
  case 229:
    valid = 1;
    break;
  case 246:
    valid = 1;
    break;
  case 260:
    valid = 1;
    break;
  case 261:
    valid = 1;
    break;
  case 263:
    valid = 1;
    break;
  case 196:
    valid = 1;
    break;
  case 197:
    valid = 1;
    break;
  case 214:
    valid = 1;
    break;
  case 258:
    valid = 1;
    break;
  case 259:
    valid = 1;
    break;
  case 330:
    valid = 1;
  }
  
  // fprintf(lg, "c=%d  valid=%d\n", c, valid);

  return(valid);
}

void cleanup_exit(char *msg, int errnum)
{
  clear();
  refresh();
  endwin();
  debug = 0;
  if (debug == 1) {
    printf("Message:   %s\n", msg);
    printf("Errnum:    %d\n", errnum);
    printf("Socket:    %d\n", S);
  } 

  if (use_fifo == 1) {
       unlink(fifo);
  }
  
  switch (errnum) {
  case 1:
    printf("%s:    %s\n", msg, strerror(errnum));
    break;
  case 2:
  	 if (pid != getpid()) 
	 	exit(0);
    printf("%s  \n", msg);
    break;
  default:
    printf("%s:    %s\n", msg, strerror(errnum));
  }

  unlink(color_temp_file);

  close(S);
  exit(3);
}






int clearWi(int size) 
{
  char clearbuf[8192];
  
  set_ncolor(".Winput", color_temp_file, Wi);
  memset(clearbuf, 0, sizeof(clearbuf));
  memset(clearbuf, ' ', size);
  
  wmove(Wi, 0, 0);
  wprintw(Wi, "%s", clearbuf);
  wmove(Wi, 0, 0);
  wrefresh(Wi);
  
  return(0);
}


char *datestr(FILE *logfile)
{
  time_t stime;
  char datestr[64];
  char *ret;
  char tmp[64];
  struct tm *TM;
  char mnts[13][4] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", 
		"Aug", "Sep", "Oct", "Nov", "Dec",0};

  stime = time(NULL);
  TM   = localtime(&stime);
  
  memset(datestr, 0, sizeof(datestr));
  strcat(datestr, mnts[TM->tm_mon]);
  sprintf(tmp, "%d", TM->tm_mday);
  strcat(datestr, " ");
  strcat(datestr, tmp);
  memset(tmp, 0, sizeof(tmp));
  sprintf(tmp, "%d", TM->tm_hour);
  strcat(datestr, " ");
  strcat(datestr, tmp);
  strcat(datestr, ":");
  memset(tmp, 0, sizeof(tmp));
  sprintf(tmp, "%d", TM->tm_min);
  strcat(datestr, tmp);
  strcat(datestr, " -- ");
  // fprintf(logfile, "%s", datestr);
}

int do_commands(char *filename)
{
  FILE *cmdfh;
  char tmp_buf[255];
  fd_set rfds_S;
  struct timeval tv;
  int data_on_sock;

  if ((cmdfh = fopen(filename, "r")) == NULL) {
    wclear(Wi);
    wmove(Wi, 0, 0);
    wprintw(Wi, "Command file failed: %s!!! ", strerror(errno));
    wrefresh(Wi);
    sleep(5);
    wclear(Wi);
    wrefresh(Wi);
    return(0);
  }
  
  while(fgets(tmp_buf, sizeof(tmp_buf), cmdfh) != NULL) {
    write(S, tmp_buf, strlen(tmp_buf));
    FD_ZERO(&rfds_S);
    FD_SET(S, &rfds_S);
    tv.tv_sec = 0;
    tv.tv_usec = 5000;
    data_on_sock = -1;
    data_on_sock = select(S+1, &rfds_S, NULL, NULL, &tv);
    switch (data_on_sock) {
    case 0:
      continue;      
    case -1:
      continue;      
    default:
      recv_text();
      continue;
    }
  }

  fclose(cmdfh);
}






int emacs_check(int c)
{
  int diff;
  int i, org_x;
  char tmp_text[BUFSIZE];
  
  // Check meta characters first.
  if (metachar == 1) {
    switch(c) {
    case 'd':
      org_x = x;
      i = 0;
      send_text[x] = 0;
      while( send_text[x] != ' ' && x != max_x) {
	x++;
      }
      if (x < max_x) x++;
      while(  x <= max_x) {
	tmp_text[i] = send_text[x];
	// fprintf(lg, "tmp_text=%d = send_text[%c] (%d)\n", c, x);
	i++; x++;
      }
      tmp_text[i] = 0;
      send_text[x] = 0;
      // fprintf(lg, "temp_text = <%s>\nsend_text = <%s>\n", tmp_text, send_text);
      x = org_x;
      strcat(send_text, tmp_text);
      max_x = strlen(send_text);
      wmove(Wi, Wi_y, x);
      wprintw(Wi, "%s", send_text);
      wrefresh(Wi);
      break;
    case 'b':
      if (send_text[x-1] == ' ') x--;
      while (send_text[x-1] != ' ' && x != 0) {
	x--;
      }
      while (send_text[x] != ' ' && x != 0) {
	// fprintf(lg, "Hit on M-f x = %d, max_x=%d\n", x, max_x);
	x--;
      }
      if (x != 0) x++;
      wmove(Wi, Wi_y, x);
      wrefresh(Wi);
      break;
    case 'f':
      while (send_text[x] != ' ' && x != max_x) {
	// fprintf(lg, "Hit on M-f x = %d, max_x=%d\n", x, max_x);
	x++;
      }
      while (send_text[x] == ' ' && x != max_x) {
	x++;
      }
      wmove(Wi, Wi_y,x);
      wrefresh(Wi);
      break;
    }
    return(0);
  }

  // if c-x -> %c is pressed.
  if (C_x_char == 1) {
    switch(c) {
    case 117: // C-x u  Undo.
      // fprintf(lg, "got C-x u\n");
      regular_char = 0;
      clearWi(BUFSIZE);
      strcpy(send_text, undo_buf);
      max_x = strlen(send_text);
      wprintw(Wi, "%s   ", send_text);
      wmove(Wi, Wi_y, x);
      wrefresh(Wi);
      return(0);
      break;
      
    }
  }

  // Check -> C-l
  if (c == 12) {
    regular_char = 0;
    wclear(Wt); wrefresh(Wt);
    clearWi(BUFSIZE);
    return(0);
  }

  // check -> C-u 
  if ( c == 21 ) {
    regular_char = 0;
    clearWi(BUFSIZE);
    memset(send_text, 0, sizeof(send_text));
    x = 0;
    max_x = 0;
    if (Cl_sec1 != 0) {
      Cl_sec2 = time(NULL);
      diff = Cl_sec2 - Cl_sec1;
      if (diff <= 1) {
	wclear(Wt); wrefresh(Wt);
	Cl_sec1 = 0; Cl_sec2 = 0;
	return(0);
      } else {
	Cl_sec1 = 0; Cl_sec2 = 0;
      }
    } else {
      Cl_sec1 = time(NULL);
    }
    return(0);
  }

  // Check C-a
  if (c == 1) {
    clearWi(BUFSIZE);
    wmove(Wi, getcury(Wi), 0);
    x = 0;
    regular_char = 0;
  }

  // Check C-e
  if (c == 5) {
    clearWi(BUFSIZE);
    wmove(Wi, getcury(Wi), max_x);
    x = max_x;
    regular_char = 0;
  }

  // Check C-k, Kill-to-end-of-line
  if (c == 11) {
    clearWi(BUFSIZE);
    wrefresh(Wi);
    send_text[x] = 0;
    max_x = x;
    regular_char = 0;
  }
}













void get_logged_in(void) {
  char tmp_buf[1024];  
	char users[25][50];
  fd_set rfds_S;
  struct timeval tv;
  int data_on_sock;
	int in_buf, in_users, user, save;
	
	memset(tmp_buf, 0, sizeof(tmp_buf));
	memset(users, 0, sizeof(users));
  
  fprintf(lg, "============= Alarmed! check logged in ================\n");

  FD_ZERO(&rfds_S);
  FD_SET(S, &rfds_S);
  tv.tv_sec = 0;
  tv.tv_usec = 5000;
  data_on_sock = -1;
  data_on_sock = select(S+1, &rfds_S, NULL, NULL, &tv);
  switch (data_on_sock) {
  case 0:
    sprintf(tmp_buf, ".w\n");
    write(S, tmp_buf, strlen(tmp_buf));
    read(S, tmp_buf, 1024);
    fprintf(lg, "got users:\n");
    fprintf(lg, "%s", tmp_buf);
    fprintf(lg, "----end of get users----\n");

		in_buf = 0;
		in_users = 0;
		user = 0;
		while(tmp_buf[in_buf] != '\0') {
			// fprintf(lg, "%c ", tmp_buf[in_buf]);
			if ( tmp_buf[in_buf-1] == ']' && isdigit(tmp_buf[in_buf-2]) != 0 ) {
				save = 1;
			}
			if ( tmp_buf[in_buf] == ' ' ) {
				if (save == 1) {
					users[user][in_users+1] = '\0';
					user++;
					in_users = 0;
				}
				save = 0;
			}
			if (save == 1) {
				fprintf(lg, "save=<%c>\n", tmp_buf[in_buf]);
				users[user][in_users] = tmp_buf[in_buf];
				in_users++;
			}
			in_buf++;
		}

		fprintf(lg, "user0=<%s>\n", users[0]);
		fprintf(lg, "user1=<%s>\n", users[1]);
    break;
  case -1:
    return;
  default:
    recv_text();
    return;
  }

}


get_options(int argc, char **argv)
{
  int opt;
  memset(naken_host, 0, sizeof(naken_host));
  memset(color_rc_file, 0, sizeof(color_rc_file));
  memset(myname, 0, sizeof(myname));

  while((opt = getopt(argc, argv, "s:p:f:n:t:?l:eP:b")) != -1 ) {
    switch(opt) {
    case 's':
      strcpy(naken_host, optarg);
      break;
    case 'p':
      naken_port = atol(optarg);
      break;
    case 'f':
      strcpy(color_rc_file, optarg);
      break;
    case 'n':
      strcpy(myname, ".n ");
      strcat(myname, optarg);
      strcat(myname, "\n");
      break;
    case 't':
      naken_timeout = atol(optarg);
      break;
    case 'l':
      memset(logfile, 0, sizeof(logfile));
      log_to_file = 1;
      strcpy(logfile, optarg);
      break;
    case 'e':
      logdate = 1;
      break;
    case 'P':
	 	use_fifo = 1;
      memset(fifo, 0, sizeof(fifo));
      strcpy(fifo, optarg);
		write_fifo("NULL", 1);
      break;
    case 'b':
		disable_beep = 1;	
      break;
    case '?':
      print_usage();
    }
  }

  if (strlen(naken_host) == 0) {
    if (getenv("NAKEN_HOST") != NULL) {
      strcpy(naken_host, getenv("NAKEN_HOST"));
    } else {
      print_usage();
    }
  }

  if (naken_port == 0) {
    if (getenv("NAKEN_PORT") != NULL) {
      naken_port = atol(getenv("NAKEN_PORT"));
    } else {
      naken_port = DEFAULT_NAKEN_PORT;
    }
  }
  
  if (naken_timeout == 0) {
    naken_timeout = DEFAULT_NAKEN_TIMEOUT;
  }

  if (strlen(color_rc_file) == 0) {
    strcpy(color_rc_file, getenv("HOME"));
    strcat(color_rc_file, "/");
    strcat(color_rc_file, DEFAULT_COLOR_RC_FILE);
  }

  if (getenv("NAKEN_NAME") != NULL) {
    if (strlen(myname) == 0) {
      strcpy(myname, ".n");
      strcat(myname, getenv("NAKEN_NAME"));
      strcat(myname, "\n");
    }
  }
  
  if (getenv("NAKEN_LOGFILE") != NULL) {
    if (strlen(logfile) == 0) {
      strcpy(logfile, getenv("NAKEN_LOGFILE"));
      log_to_file = 1;
    }
    if (getenv("NAKEN_LOGDATE") != NULL) {
      logdate = atol(getenv("NAKEN_LOGDATE"));
    }
  }
  
}







int handle_input(void)
{
  int mv_cnt;
  int len;
	int res;
  char tmp_clear[BUFSIZE];
  
  touchwin(Wi);
  regular_char = 1;
  c = wgetch(Wi);    
  Wi_x = getcurx(Wi);
  Wi_y = getcury(Wi);
  
  if (c == -1) {
    return(0);
  }
  
	if (c == ' ' || c == 1 || c == 4 || c == 5 || c == 27) {
	 	tab_complet(3);
	}
 
 	last_char = c;

  if (metachar == 1) {
    emacs_check(c);
    regular_char = 0;
    metachar = 0;
    clearWi(BUFSIZE);
    wprintw(Wi, "%s", send_text);
    wmove(Wi, 0, x);
    wrefresh(Wi);
    return(0);
  }
  if (c == 27) {
    metachar = 1;
    return(0);
  } else {
    metachar = 0;
  }
  
  if (C_x_char == 1) {
    clearWi(BUFSIZE);
    wprintw(Wi, "%s", send_text);
    wmove(Wi, 0, x);
    wrefresh(Wi);
    emacs_check(c);
    C_x_char = 0;
    return(0);
  }
  if (c == 24) {
    clearWi(BUFSIZE);
    wprintw(Wi, "%s", send_text);
    wmove(Wi, 0, x);
    wrefresh(Wi);
    C_x_char = 1;
    return(0);
  } else {
    C_x_char = 0;
  }
  
  if (check_valid_keys(c) == 0) {
    // Not a valid key.
    wmove(Wi, 0, 0);
    wprintw(Wi, "%s", send_text);
    wmove(Wi, 0, x);
    wrefresh(Wi);
    return(0);
  }
  
  
  emacs_check(c);
  switch(c) {
  case 9:
    regular_char = 0;
    // strcat(send_text, "Whoow");
		tab_complet(0);
    max_x = strlen(send_text);
    x = max_x;
    break;
  case 8:
    regular_char = 0;
    c = 263;
  case 330: // Delete key
    regular_char = 0;
    c = 263;
  case 263: // backspace
    if (x == 0) return(0);
    clearWi(BUFSIZE);
    if (x != max_x) {
      x--;
      mv_cnt = x;
      len = strlen(send_text);
      while(mv_cnt != len) {
	send_text[mv_cnt] = send_text[mv_cnt + 1];
	mv_cnt++;
      }
      max_x--;
      send_text[max_x] = 0;
      regular_char = 0;
    } else {
      if (x != 0) {
	x--;
	max_x--;
      }
      log(x, max_x, "x max_x");
      send_text[x] = 0;
      send_text[max_x] = 0;
      regular_char = 0;
    }
    break;
  case 258: // arrow down
    strcpy(history[max_history - in_history], send_text);
    trav_history(0);
    regular_char = 0;
    break;
  case 259: // arrow up
    strcpy(history[max_history - in_history], send_text);
    trav_history(1);
    regular_char = 0;
    break;
  case 260: // Left arrow
    if (x != 0) {
      x--;
      wmove(Wi, 0, x); wrefresh(Wi); 
    }
    regular_char = 0;
    break;
  case 261: // Right arrow
    if (x != max_x) {
      x++;
      wmove(Wi, 0, x); wrefresh(Wi); 
    }
    regular_char = 0;
    break;
  }
  
  if (x == (BUFSIZE - 1) && x != '\n' ) {
    // fprintf(lg, "Buffer is full! %d == %d || %c != BS\n", x, BUFSIZE - 1, x);
    return(0);
  }
  
  if (c == '\n') {
    if (max_x == 0) 
      return;
    send_text[max_x] = '\n';
    max_x++;
    send_text[max_x] = '\0';
    
    // History
    if ( max_history == HIST ) {
      // History is full.
      trav_history(2);
    }
	
		res = 10;
		if (max_history != 0) {
			strcpy(tmp_clear, send_text);
			// fprintf(lg, "last in send_text: <%d>\n", tmp_clear[max_x-1]);
			tmp_clear[max_x-1] = '\0';
			res = strcmp(tmp_clear, history[max_history - 1]);
		}
		if (res != 0) {
		  strcpy(history[max_history], send_text);
		  in_history = 0;
			history[max_history][max_x-1] = '\0';
			max_history++;
		}
    
    
    
    if (check_local_command(send_text) == 1) {
      memset(tmp_clear, ' ', strlen(tmp_clear));
      wprintw(Wi, "%s", tmp_clear);
      wmove(Wi, 0, 0);
      wrefresh(Wi);
      x = 0;
      max_x = 0;
      memset(send_text, 0, strlen(send_text));
      set_ncolor(".Winput", color_temp_file, Wi);
      nodelay(Wi, TRUE);
      return(0);
    }
    write(S, send_text, strlen(send_text));
    wrefresh(Wt);
    clearWi(BUFSIZE);
    send_text[max_x] = '\0';
    x = 0;
    max_x = 0;
    memset(send_text, 0, sizeof(send_text));
    return(0);
  } else {
    if (regular_char == 1) { // This is a reg. character, save this
      if (x != max_x) {
	mv_cnt = strlen(send_text);
	while(mv_cnt != x-1) {
	  send_text[mv_cnt + 1] = send_text[mv_cnt];
	  mv_cnt--;
	}
	max_x++;
	send_text[max_x] = 0;
      }
      send_text[x] = c;	
      if (x == max_x) {
	max_x++;
      }
      x++;
    }
  }
  
  send_text[max_x] = 0;
  strcpy(undo_buf, send_text);
  wmove(Wi, 0, 0);
  wprintw(Wi, "%s", send_text); 
  wmove(Wi, 0, x);  wrefresh(Wi);
  send_text[max_x] = '\0';
}


// way in:
// 0 = go forward in hist.
// 1 = go back in hist.
// 2 = handle if the buffer is full, delete the oldest entry.

void trav_history(int way) 
{
	int c;

	if (way == 0) {
		if (in_history <= 0) {
			return;
		} 

		in_history--;

		strcpy(send_text, history[max_history - in_history]);
		max_x = strlen(send_text);
		x = max_x;
		clearWi(BUFSIZE);
		wrefresh(Wi);
	}


	if (way == 1) {
		if (in_history == max_history) {
			return;
		}

		in_history++;

		strcpy(send_text, history[max_history - in_history]);
		max_x = strlen(send_text);
		x = max_x;
		clearWi(BUFSIZE);
		wrefresh(Wi);
	}


	c = 0;
	if (way == 2) {
		while(c < HIST) {			
			strcpy(history[c], history[c+1]);
			c++;
		}
		max_history--;
	}
}
int log (int X, int C, char *msg)
{
  wprintw(logwin, "x=%03d, c=%c\n", X, C); wrefresh(logwin);
}


void print_usage(void)
{
  endwin();  
  printf("Usage: naken_curs <-s naken_server> [options]\n");
  printf("   options:\n");
  printf("       -s SERVER   : Naken-servers ip or hostname.\n");
  printf("                     Variable \"NAKEN_HOST\" can be used.\n");
  printf("       -p PORT     : Naken-server port (Default 6666).\n");
  printf("                     Variable: \"NAKEN_PORT\" can be used.\n");
  printf("       -t TIMEOUT  : Connection timeout.\n");
  printf("       -f RC_FILE  : Color rc file (Default $HOME/.naken_color).\n");
  printf("       -n NAME     : Sets your name in chat server.\n");
  printf("                     Variable: \"NAKEN_NAME\" can be used.\n");
  printf("       -l FILE     : Add logging of chat msgs to file \"FILE\".\n");
  printf("                     Variable: \"NAKEN_LOGFILE\" can be used.\n");
  printf("       -e          : Add timestamps of each message i logfile.\n");
  printf("                     Variable \"NAKEN_LOGDATE\" with value \"1\"\n");
  printf("       -b          : Disable \"beep\" and \"flash\" on private messages\n");
  printf("       -P FIFO_FILE: Also send all recived text trough \"FIFO_FILE\".\n");
  printf("                     Good for attaching other scripts that can take -\n");
  printf("                     action on different messages.\n");
  printf("       -?          : This help message.\n\n");
  printf("   Naken_Curs local commands:\n");
  printf("       .adduser    : Add a user color.\n");
  printf("       @<file>     : Takes line by line in file and send's it.\n");  
  printf("\n");
  printf("naken_curs, Version %s\n", VERSION);
  printf("Erik Ahlstrm, seeah@proact.se\n");

  
  exit(1);
}


int recv_text(void)
{
  char buf[1024];
  char line[1024];
  int  count1, count2;
  int  size;
  FILE *msg_log;

  memset(buf, 0, 1024);
  memset(line, 0, sizeof(line));
  read(S, buf, 1024);
  size = strlen(buf);

  if (use_fifo == 1) {
	  write_fifo(buf, 0);
  }

  if (disable_beep != 1) {
	 if (buf[0] == '<') {
		  beep();
		  flash();
	 }
  }

  count1 = 0;
  count2 = 0;
  while(count1 != size) {
    if (buf[count1] == '\r') {
      line[count2] = '\r';
      line[count2+1] = '\0';
      count1++;
      set_ncolor(line, color_temp_file, Wt);
      wprintw(Wt, "%s", line); wrefresh(Wt);
      // fprintf(lg, "logfile=<%s> log_to_file=<%d> logdate=<%d>\n", logfile, log_to_file, logdate);
      if (log_to_file == 1) {
	if ((msg_log = fopen(logfile, "a")) != NULL) {
	  if (logdate == 1) {
	    datestr(msg_log);
	  }
	  // fprintf(msg_log, "%s", line);
	  fclose(msg_log);
	}
      }
      memset(line, 0, sizeof(line));
      count2 = 0;
      continue;
    } else {
      line[count2] = buf[count1];
    }
    count2++;
    count1++;
  }
}




int set_color(void)
{
  

}


set_ncolor(char *text, char *temp_file, WINDOW *win)
{
  FILE *fp_temp;
  char temp_buf[255];
  char name[255];
  char c_pair[16];
  char *find;
  int  pair, found;
  int  x, x1;
  

  if ((fp_temp = fopen(temp_file, "r")) == NULL ) {
    return(-13);
  }
  memset(name, 0, sizeof(name));
  if (strcmp(text, ".default_user") == 0 
      || strcmp(text, ".Winput") == 0
      || strcmp(text, ".Wtext") == 0 ) {
    strcpy(name, text);
  } else {
    x = 0;
    x1 = 0;
    if (text[0] != '[') {
      set_ncolor(".Wtext", color_temp_file, win);
      return(0);
}
    while (text[x] != ']' && strlen(text) > x ) {
      x++;
    }
    x++;
    while (text[x] != ' ' && strlen(text) > x ) {
      if (text[x] == ':') {
	break;
      }
      name[x1] = text[x];
      x++;
      x1++;
    }
    name[x1] = '\0';
  }
  
  if (strcmp(name, "") == 0 ) {
      strcpy(name, ".Wtext");
  }


  while ((fgets(temp_buf, sizeof(temp_buf), fp_temp)) != NULL ) {
    if (strstr(temp_buf, name) == NULL) {
      continue;
    } else {
      found = 1;
    }

    x  = 0;      
    while (temp_buf[x] != '=' && strlen(temp_buf) > x ) {
      x++;
    }

    x1 = 0;
    x++;
    while (temp_buf[x] != 10 && strlen(temp_buf) > x ) {
      c_pair[x1] = temp_buf[x];
      x++;
      x1++;
    }
    
    c_pair[x1] = '\0';
  }

  if (found == 1) {
    pair = atol(c_pair);
  } else {
    set_ncolor(".default_user", color_temp_file, win);
    return(0);
  }

  wcolor_set(win, pair, NULL);
  fclose(fp_temp);
}
void set_timer(int time_out_sec)
{
	struct itimerval itv;

	itv.it_interval.tv_usec = 0;
	itv.it_interval.tv_sec = 0;
	itv.it_value.tv_usec = 0;
	itv.it_value.tv_sec = time_out_sec;
	setitimer(ITIMER_REAL, &itv, (struct itimerval *) 0);
}


int set_up_color(char *rcfile, char *temp_file)
{
  char name[255]; 
  char *env;
  char *find;
  char color1[16], color2[16];
  int x, x1;
  int find_len;
  FILE *fp, *fp_temp;
  char rc_buf[255];
  // define colors
  int col_fg, col_bg, color;
  int def;
  int pair = 10;
  int no_rc = 0;

  if ((fp = fopen(rcfile, "r")) == NULL ) {
    no_rc = 1;
  }

  if ((fp_temp = fopen(temp_file, "w")) == NULL ) {
    return(-12);
  }

  if (no_rc == 1) {
    if ((fp = fopen(rcfile, "w")) == NULL ) return(-1);
    fprintf(fp, "## System vars:
##   .default_user = User not known.
##   .Winput       = Input window.
##   .Wtext        = Server messages, ex. \".help\" output.
.default_user=1:0
.Winput=3:0
.Wtext=2:0
##
## <NAME_OF_USER>=<FG_COLOR>:<BG_COLOR>
eah=5:0
");
    no_rc = 0;
    
    wclear(Wt);
    wmove(Wt, 0,0);
    wprintw(Wt, "Created color setup file: %s\n\n", color_rc_file);
    wprintw(Wt, "Please restart naken_curs to enable colors\n");
    wprintw(Wt, "\nPress a key to end.\n");
    wrefresh(Wt);
    getch();
    clear(); refresh();
    endwin();
    exit(0);
  }
  
  start_color();

  while ((fgets(rc_buf, sizeof(rc_buf), fp)) != NULL ) {
    memset(name, 0, sizeof(name));
    memset(color1, 0, sizeof(color1));
    memset(color2, 0, sizeof(color2));
    
    if (rc_buf[0] == '#' || rc_buf[0] == ';' ) {
	continue;
    }

    if (strstr(rc_buf, "=") == NULL) {
      continue;
    }
    
    find_len = strlen(rc_buf);
    x = 0;
    while (rc_buf[x] != '=' &&  x < find_len ) {
      name[x] = rc_buf[x];
      x++;
    }
    name[x] = '\0';
    if (rc_buf[x] != '=') {
      continue;
    } else {
      x++;
    }
                
    find_len = strlen(rc_buf);
    x1 = 0;
    while(rc_buf[x] != ':' &&  x < find_len) {
      color1[x1] = rc_buf[x];
      x1++;
      x++;
    }
    color1[x1] = '\0';
    if (rc_buf[x] != ':' ) {
      continue;
    } else {
      x++;
    }
     
    x1 = 0;
    while(rc_buf[x] != '\n' && x < find_len) {
      color2[x1] = rc_buf[x];
      x1++;
      x++;
    }
    color2[x1] = '\0';
        
    col_fg = atol(color1);
    col_bg = atol(color2);
    
    init_pair(pair, col_fg, col_bg);
    fprintf(fp_temp, "%s=%d  (%d:%d)\n", name, pair, col_fg, col_bg);
    pair++;
    refresh();
  }
  
  fclose(fp);
  fclose(fp_temp);
  return(0);
}
int set_up_windows(void)
{
  int input_win_rows;
  int Wi_start, Delim_start;
  int Delim_rows = 1;

  if (lines_org != 0 && cols_org != 0) {
    delwin(Wi);
    delwin(Wt);
    delwin(Delim);
    clear();
    refresh();
  }
  lines_org = LINES;
  cols_org  = COLS;
  

  input_win_rows = 2;
  Delim_rows = 1;

  Wt_lin = LINES - input_win_rows - Delim_rows - 1;
  Wt_col = COLS;
  
  Wi_lin = input_win_rows;
  Wi_col = COLS;
  Wi_start = Wt_lin + 1;
  Delim_start = Wt_lin;

  Wt = newwin(Wt_lin, Wt_col, 0, 0);
  Wi = newwin(Wi_lin, Wi_col, Wi_start, 0);
  Delim = newwin(1, Wt_col, Delim_start, 0);

  // memset(send_text, '-', COLS);
  memset(send_text, DELIM_CHAR, COLS);
  wprintw(Delim, "%s", send_text);
  wmove(Delim, 0, COLS / 2 - 19);
  // wprintw(Delim, " Author: Erik Ahlstrm, eah@proact.se ");
  wrefresh(Wt);   wrefresh(Wi);  wrefresh(Delim);
  memset(send_text, 0, COLS);
  // fprintf(lg, "Wt_lin=%d, Wi_start=%d, Delim=%d\n", Wt_lin, Wi_start, Delim_start);

  meta(Wi, TRUE);  
  keypad(Wi, TRUE);  
  nodelay(Wi, TRUE);
  scrollok(Wi, TRUE);
  scrollok(Wt, TRUE);
  return(0);
}



void sig_handler(int sig)
{
  if (S < 0) {
    cleanup_exit("No answer from host!", 1);
  }

  if (sig == SIGINT) {
    cleanup_exit("Bye, Bye, Have a nice day! //eah", 2);
  }
}

int tab_complet(int comm) {
	char dbfile[255];
	char db[255];
	char match[BUFSIZE];
	char all_match[db_lines+10][db_maxlen+10];
	char clr[COLS];
	char show_match[BUFSIZE];
	FILE *dbfh;
	int	 hits, check_hits;
	int  cnt, cnt2, stop, in_org, in_match;
	int  res;
	int  match_number;
	int  match_org_len;

	memset(dbfile, 0, sizeof(dbfile));
	memset(db, 0, sizeof(db));
	memset(match, 0, sizeof(db));
	memset(all_match, 0, sizeof(all_match));
	memset(show_match, 0, sizeof(show_match));
	
	sprintf(dbfile, "%s/%s", getenv("HOME"), ".ncurs_db");

	if (comm == 1) {
		if ((dbfh = fopen(dbfile, "r")) == NULL) {
			// fprintf(lg, "cannot open dbfile\n");
			ncurs_db_errno = errno;
			return(-1);
		} 
		db_lines = 0;
		db_maxlen = 0;
		while( fgets(db, 255, dbfh) != NULL ) {
			db_lines++;
			if (strlen(db) > db_maxlen) {
				db_maxlen = strlen(db);
			}
		}
		// fprintf(lg, "==== setup complete: lines %d, len %d\n", db_lines, db_maxlen);
		fclose(dbfh);
		return(0);
	}

	if (comm == 3) {
		memset(clr, DELIM_CHAR, COLS);	
		wmove(Delim, 0, 0);
		wprintw(Delim, "%s", clr);
		wrefresh(Delim);
		return(0);
	}

	// Some thing was not ok with setup.
	if (ok_complet != 0) {
		wmove(Delim, 0, 1);
		wprintw(Delim, " $HOME/.ncurs_db: %s ", strerror(ncurs_db_errno));
		wrefresh(Delim);
		return(-1);
	}


	
	// dont check tab as first char...
	if (x == 0) 
		return(0);
	// or if in line -1 char is space
	if (send_text[x-1] == ' ') 
		return(0);


	if ((dbfh = fopen(dbfile, "r")) == NULL) {
		// fprintf(lg, "cannot open dbfile\n");
		return;
	}

	in_match = 0;
	in_org = 0;
	while(in_org != max_x) {
		if (send_text[in_org] == 32) {
			in_match = 0;
			in_org++;
			continue;
		}
		match[in_match] = send_text[in_org];
		
		in_match++; in_org++;
	}
	match[in_match] = '\0';

	cnt = 0;
	hits = 0;
	// while(cnt < 4) {
	// fprintf(lg, "------ lines %d --- chars %d ------\n", db_lines, db_maxlen );
	while( fgets(db, BUFSIZE, dbfh) != NULL ) {
		res = strncmp(db, match, strlen(match));
		if ( res == 0 ) {
			db[strlen(db) - 1] = '\0';
			// Dont add this if it's already in all_match.
			cnt2 = 0;
			// To tired to think today, why does not break(2) work?
			stop = 0;
			while(all_match[cnt2][0] != '\0') {
				res = strcmp(all_match[cnt2], db);
				if (res == 0) {
					stop = 1;
					break;
				}
				cnt2++;
			}
			if (stop == 1) {
				break;
			}
			strcpy(all_match[hits], db);
			if ( (sizeof(show_match) - strlen(show_match)) > 50 ) {
				strcat(show_match, " ");
				strcat(show_match, db);
			}
			// fprintf(lg, "all_match[%d] = %s\n", hits, all_match[hits]);
			memset(db, 0, sizeof(db));
			hits++;
			if (hits > 30) 
				break;

		}
		cnt++;	
	}
	
	if (hits == 0) {
		tab_complet(3);
		return;
	}
	
	if (hits == 1) {
		send_text[max_x - strlen(match)] = '\0';
		strcat(send_text, all_match[0]);
		max_x = strlen(send_text);
		send_text[max_x] = 32;
		send_text[max_x+1] = '\0';
		tab_complet(3);
		// fprintf(lg, "send clear...\n");
		fclose(dbfh);
		return(0);
	}

	match_number = strlen(match);
	cnt2 = 1;
	check_hits = hits;
	if (hits > 1) {
		match_org_len = strlen(match);
		while(check_hits == hits) {
			if ((strlen(all_match[0]) + 1) == match_number) {
				// fprintf(lg, "Break in line: 90\n");
				check_hits = 0;
				break;
			}

			memset(match, 0, sizeof(match));
			strncpy(match, all_match[0], match_number);
			match[match_number+1] = '\0';
			cnt = 0;
			check_hits = 0;
			while (cnt <= hits) {
				res = strncmp(all_match[cnt], match, strlen(match));
				if (res == 0) {
					check_hits++;	
					// fprintf(lg, "strncmp(cmp cnt=%d => %s, %s, %d  (H-%d, CH-%d)\n", cnt, all_match[cnt], match, strlen(match), hits, check_hits);
				}
				cnt++;
			}
			if (check_hits == hits) {
				memset(db, 0, sizeof(db));
				strcpy(db, match);
			}
			cnt2++;
			match_number++;
		}

		// fprintf(lg, "====> match in now db: <%s> <%d>\n", db, hits);
		tab_complet(3);
		wmove(Delim, 0, 1);
		if (strlen(show_match) > (COLS + 1)) {
			memcpy(clr, show_match, COLS - 6);
			strcat(clr, "......");
		} else {
			memcpy(clr, show_match, COLS - 2);
		}
		wprintw(Delim, "%s ", clr);
		wrefresh(Delim);
		// fprintf(lg, "====> printed in delim\n ");
		

		send_text[max_x - match_org_len] = '\0';
		strcat(send_text, db);
		max_x = strlen(send_text);
		x = max_x;
	}



	fclose(dbfh);
}

void welcome_msg(WINDOW *win)
{

}

int write_fifo(char *string, int command) {
	int fd_pipe;

	if (command == 1) {
		if (mkfifo(fifo, 0000) < 0)  {
			 perror("mkfifo");
			 exit(1);
		}
		if (chmod(fifo, S_IREAD|S_IWUSR) < 0) {
			 perror("chmod: chmod");
			 exit(1);
		}
	}

	if ( (fd_pipe = open(fifo, O_WRONLY|O_NONBLOCK)) < 0 ) {
		// No one is listening on fifo, just go on..
		if (errno == ENXIO)
		  return(0);

		perror("open fifo");
		exit(1);
	}

	if (write(fd_pipe, string, strlen(string)) != strlen(string)) {
		perror("write failed");
		exit(1);
	}

	close(fd_pipe);
}

