

get_options(int argc, char **argv)
{
  int opt;
  memset(naken_host, 0, sizeof(naken_host));
  memset(color_rc_file, 0, sizeof(color_rc_file));
  memset(myname, 0, sizeof(myname));

  while((opt = getopt(argc, argv, "s:p:f:n:t:?l:eP:b")) != -1 ) {
    switch(opt) {
    case 's':
      strcpy(naken_host, optarg);
      break;
    case 'p':
      naken_port = atol(optarg);
      break;
    case 'f':
      strcpy(color_rc_file, optarg);
      break;
    case 'n':
      strcpy(myname, ".n ");
      strcat(myname, optarg);
      strcat(myname, "\n");
      break;
    case 't':
      naken_timeout = atol(optarg);
      break;
    case 'l':
      memset(logfile, 0, sizeof(logfile));
      log_to_file = 1;
      strcpy(logfile, optarg);
      break;
    case 'e':
      logdate = 1;
      break;
    case 'P':
	 	use_fifo = 1;
      memset(fifo, 0, sizeof(fifo));
      strcpy(fifo, optarg);
		write_fifo("NULL", 1);
      break;
    case 'b':
		disable_beep = 1;	
      break;
    case '?':
      print_usage();
    }
  }

  if (strlen(naken_host) == 0) {
    if (getenv("NAKEN_HOST") != NULL) {
      strcpy(naken_host, getenv("NAKEN_HOST"));
    } else {
      print_usage();
    }
  }

  if (naken_port == 0) {
    if (getenv("NAKEN_PORT") != NULL) {
      naken_port = atol(getenv("NAKEN_PORT"));
    } else {
      naken_port = DEFAULT_NAKEN_PORT;
    }
  }
  
  if (naken_timeout == 0) {
    naken_timeout = DEFAULT_NAKEN_TIMEOUT;
  }

  if (strlen(color_rc_file) == 0) {
    strcpy(color_rc_file, getenv("HOME"));
    strcat(color_rc_file, "/");
    strcat(color_rc_file, DEFAULT_COLOR_RC_FILE);
  }

  if (getenv("NAKEN_NAME") != NULL) {
    if (strlen(myname) == 0) {
      strcpy(myname, ".n");
      strcat(myname, getenv("NAKEN_NAME"));
      strcat(myname, "\n");
    }
  }
  
  if (getenv("NAKEN_LOGFILE") != NULL) {
    if (strlen(logfile) == 0) {
      strcpy(logfile, getenv("NAKEN_LOGFILE"));
      log_to_file = 1;
    }
    if (getenv("NAKEN_LOGDATE") != NULL) {
      logdate = atol(getenv("NAKEN_LOGDATE"));
    }
  }
  
}





