
/* This program is licensed by the well known GPL license, */
/* (Gnu General Public License) */
/* Bug reports, RFE's or comments can be sent to author: */
/* Erik Ahlstrm, eah@proact.se, (or seeah@linux.com, prio 2) */


#include "include/naken_curs.h"


int main(int argc, char **argv)
{

  fd_set rfds_S;
  struct timeval tv;
  int data_on_sock;
  long re_read_config = 0;

  pid = getpid();


  // lg = fopen("/dev/null", "w");
  // lg = fopen("/dev/pts/0", "w");
  
  get_options(argc, argv);

  signal(SIGINT, sig_handler);
  initscr();
  noecho();
  start_color();
  
  printw("Connecting to %s on port %d, Timeout is %d seconds.",
		naken_host, naken_port, naken_timeout);
  refresh();
  usleep(500000);
  S = call_server(naken_host, naken_port, naken_timeout);    

  // Set up temp file
  sprintf(color_temp_file, "/tmp/%s.%d", COLOR_TEMP_FILE, getpid());

  set_up_windows();
  set_up_color(color_rc_file, color_temp_file);
  set_ncolor(".Winput", color_temp_file, Wi);
  set_ncolor(".Wtext", color_temp_file, Wt);
  set_ncolor(".default_user", color_temp_file, Wt);
  wrefresh(Wt);
  wrefresh(Wi);

	// set up completion
	ok_complet = tab_complet(1);
	// fprintf(lg, "setting up complete... = %d\n", ok_complet);

  write(S, myname, strlen(myname));
  strcpy(send_text, "Connected with | Naken_Curs, version ");
  strcat(send_text, VERSION);
  strcat(send_text, " |\n");
  write(S, send_text, strlen(send_text));
  memset(send_text, 0, sizeof(send_text));

  while (1==1) {
    if (lines_org != LINES || cols_org != COLS) {
      clear();
      set_up_windows();
      refresh();
    }
    re_read_config++;

    if ( re_read_config == 1000 ) {
			set_up_color(color_rc_file, color_temp_file);
  		set_ncolor(".Winput", color_temp_file, Wi);
  		set_ncolor(".Wtext", color_temp_file, Wt);
  		set_ncolor(".default_user", color_temp_file, Wt);
			re_read_config = 0;
			// get_logged_in();
    }

    FD_ZERO(&rfds_S);
    FD_SET(S, &rfds_S);
    tv.tv_sec = 0;
    tv.tv_usec = 5000;
    data_on_sock = -1;
    data_on_sock = select(S+1, &rfds_S, NULL, NULL, &tv);
    switch (data_on_sock) {
    case 0:
      handle_input();
      break;
    case -1:
      // cleanup_exit("Select on Socket failed!", errno);
      break;
    default:
      recv_text();
      break;
    }
  }
  unlink(color_temp_file);
  close(S);
  endwin();
}
